/******************************************************************************
* Std C Prototypes
******************************************************************************/
void DSPF_sp_fftSPxSP(int N, global float *x, global float *w, global float *y, 
                      unsigned char *brev, int n_min, int offset, int n_max); 

void FFT_destroy_plan_facade (global char* plan, global char *state);
void FFT_execute_facade      (global char* plan, local float *fftbufs_pool, global char *state);
void FFT_plan_facade         (int N, int BATCH, int type, int mode, global char* plan,
			     global float * x_i, global float * y_i, global float * w_i,local float * fftbufs_pool, global char *state);

/******************************************************************************
* Kernels 
******************************************************************************/
kernel void ocl_DSPF_sp_fftSPxSP(int N, global float *x, global float *w, global float *y, 
                                 int n_min, int offset, int n_max) 
{ 
    DSPF_sp_fftSPxSP (N, x, w, y, 0, n_min, offset, n_max); 
} 

kernel void ocl_FFT_plan(int N, int BATCH, int type, int mode, global char* plan,
			     global float * x_i, global float * y_i,global float *w_i,local float * fftbufs_pool, global char *state)
{ 
    FFT_plan_facade(N, BATCH, type, mode, plan, x_i, y_i, w_i ,fftbufs_pool, state); 
}

kernel void ocl_FFT_execute(global char* plan, local float *fftbufs_pool, global char *state)
{ 
    FFT_execute_facade(plan,fftbufs_pool, state);
}

kernel void ocl_FFT_destroy_plan(global char* plan, global char *state)
{
    FFT_destroy_plan_facade(plan, state);
}
